| ISF 1.1 Intelligent Sensing Framework

- Main Page
- Data Structures
- Files
- Sensor Adapters

- File List
- Globals

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Defines
Defines | Typedefs | Functions
Include/isf_bm.h File Reference

API definitions, types, and macros for the Intelligent Sensing Framework (ISF) Bus Manager (BM). More...

Go to the source code of this file.

## Defines
#define | MAX_BM_CALLBACKS (8)
| The maximum number of callbacks registered with the Bus Manager.
#define | MAX_BM_PERIOD_USEC (60 * 1000 * 1000)
| The maximum period of a callback is provided in microseconds. Attempting to register a callback period greater than this value results in an error.
#define | MIN_BM_PERIOD_USEC (200)
| The minimum period of a callback is provided in microseconds. Attempting to register a callback period less than this value results in an error.
#define | BM_TOKEN_VAL_MAX ((bm_callback_token_t)(1 << (MAX_BM_CALLBACKS-1)))
| The largest token value assigned to a bus management callback.
#define | BM_TOKEN_VAL_ERROR ((bm_callback_token_t)(1 << ((sizeof(bm_callback_token_t)*8)-1)))
| This value is returned when the token value for the BM callback is incorrect.
#define | BM_ERROR BM_TOKEN_VAL_ERROR
| This value specifies a general Bus Manager error. If an error occurs in registering a callback, this token error value is logically OR'd with the specific nature of the error and returned.
#define | BM_ALL_TOKENS ((bm_callback_token_t)((1 << MAX_BM_CALLBACKS)-1))
| This value specifies an action to be taken on all callbacks registered with the Bus Manager.
## Typedefs
typedef void( | bm_callback_t )(void *)
| Type for the prototype for a Bus Manager periodic callback function.
typedef uint32 | bm_callback_token_t
| This type defines the Bus Manager token. Each callback registered with the Bus Manager receives a unique token value of this type. Certain Bus Manager API calls require the token value as an input parameter such as bm_start(), bm_stop(), and bm_unregister_callback().
## Functions
isf_status_t | bm_init (void)
| This API initializes the Bus Manager.
bm_callback_token_t | bm_register_periodic_callback (isf_duration_t aPeriod, bm_callback_t *apCallback, void *apCbData)
| This API schedules a callback at the specified period.
isf_status_t | bm_unregister_callback (bm_callback_token_t aTokens)
| This API unregisters one or more callbacks.
isf_status_t | bm_start (boolean aSync, bm_callback_token_t aTokens)
| This API sets one or more callback(s) to the active state.
isf_status_t | bm_stop (bm_callback_token_t aTokens)
| This API stops one or more callback(s) by setting them to the inactive state.
uint32 | bm_get_num_callback (void)
| This API returns the number of callbacks registered.

## Detailed Description

API definitions, types, and macros for the Intelligent Sensing Framework (ISF) Bus Manager (BM).

Definition in file isf_bm.h.

## Define Documentation

#define BM_ALL_TOKENS ((bm_callback_token_t)((1 << MAX_BM_CALLBACKS)-1))

This value specifies an action to be taken on all callbacks registered with the Bus Manager.

Definition at line 67 of file isf_bm.h.

#define BM_ERROR BM_TOKEN_VAL_ERROR

This value specifies a general Bus Manager error. If an error occurs in registering a callback, this token error value is logically OR'd with the specific nature of the error and returned.

Definition at line 62 of file isf_bm.h.

#define BM_TOKEN_VAL_ERROR ((bm_callback_token_t)(1 << ((sizeof(bm_callback_token_t)*8)-1)))

This value is returned when the token value for the BM callback is incorrect.

Definition at line 56 of file isf_bm.h.

#define BM_TOKEN_VAL_MAX ((bm_callback_token_t)(1 << (MAX_BM_CALLBACKS-1)))

The largest token value assigned to a bus management callback.

Definition at line 51 of file isf_bm.h.

#define MAX_BM_CALLBACKS (8)

The maximum number of callbacks registered with the Bus Manager.

Definition at line 34 of file isf_bm.h.

#define MAX_BM_PERIOD_USEC (60 * 1000 * 1000)

The maximum period of a callback is provided in microseconds. Attempting to register a callback period greater than this value results in an error.

Definition at line 40 of file isf_bm.h.

#define MIN_BM_PERIOD_USEC (200)

The minimum period of a callback is provided in microseconds. Attempting to register a callback period less than this value results in an error.

Definition at line 46 of file isf_bm.h.

## Typedef Documentation

typedef void( bm_callback_t)(void *)

Type for the prototype for a Bus Manager periodic callback function.

Definition at line 76 of file isf_bm.h.

typedef uint32 bm_callback_token_t

This type defines the Bus Manager token. Each callback registered with the Bus Manager receives a unique token value of this type. Certain Bus Manager API calls require the token value as an input parameter such as bm_start(), bm_stop(), and bm_unregister_callback().

Definition at line 84 of file isf_bm.h.

## Function Documentation

uint32 bm_get_num_callback | ( | void |  | ) |

This API returns the number of callbacks registered.

The number of registered callbacks is returned regardless of their state, active or inactive.

Returns:
  bm_get_num_callback() returns a value of type uint32 providing the number of callbacks currently registered with the Bus Manager whether they are in the active or inactive state.

Constraints:
  None

Reentrant: Yes

Link Libraries:
  isf_core.lib

isf_status_t bm_init | ( | void |  | ) |

This API initializes the Bus Manager.

The Bus Manager requires a one time initialization at system startup performed by this API call. It creates and initializes internal variables. In addition, it installs an interrupt service routine for a hardware timer to be used by the Bus Manager to schedule callbacks.

Returns:
  isf_status_t bm_init() returns a value of type isf_status_t providing the status of the initialization operation.

Return values:

  ISF_SUCCESS | This value is returned if the initialization completed successfully.
  ISF_ERR_LIB_INIT | This value is returned if the interrupt service routine for the FXLC95000 MTIM timer could not be installed.

Constraints:
  The following constraints must be observed when using this function. If these constraints are not met, this API returns an error.
  - There must not be any installed interrupt routines for the FXLC95000 MTIM timer.

Reentrant: No

Link Libraries:
  isf_core.lib

Referenced by isf_lib_init().

bm_callback_token_t bm_register_periodic_callback | ( | isf_duration_t | aPeriod,
|  | bm_callback_t * | apCallback,
|  | void * | apCbData
| ) |  |

This API schedules a callback at the specified period.

The Bus Manager schedules periodic sensor data automatically. It allows a registered callback to be automatically invoked at the specified period. Multiple callbacks registered for the same frequency are executed serially by the Bus Manager. If registration of the callback is successful, the callback is set to the inactive state. The API function bm_start() can be called to make the callback active.

Parameters:

  [in] | aPeriod | The period (1/frequency) between successive callback invocations in microseconds.
  [in] | apCallback | The pointer to the callback function to be registered.
  [in] | apCbData | The pointer passed to the callback function each time it is invoked. This pointer may be used to pass specific data to the callback function.

Returns:
  bm_register_periodic_callback() returns a token of type bm_callback_token_t if the callback registration is successful.

Return values:

  COMM_ERROR_NULL_PTR | This error value and the most significant bit of the macro BM_ERROR is returned if the callback function pointer is NULL.
  COMM_ERROR_NOEXIST | This error value and the most significant bit of the macro BM_ERROR is returned if either of the following conditions are true: The callback period is longer than MAX_BM_PERIOD_USEC or shorter than MIN_BM_PERIOD_USEC. The callback under registration exceeds the maximum number of callbacks allowed.

Constraints:
  The following constraints must be observed when using this function. If these constraints are not met, this API returns an error.
  - aPeriod must be within the valid range of MIN_BM_PERIOD_USEC to MAX_BM_PERIOD_USEC for the bus being initialized.
  - apCallback callback function pointer must not be NULL.
  - The number of callbacks registered must not exceed the maximum specified by MAX_BM_CALLBACKS.

Reentrant: Yes

Link Libraries:
  isf_core.lib

isf_status_t bm_start | ( | boolean | aSync,
|  | bm_callback_token_t | aTokens
| ) |  |

This API sets one or more callback(s) to the active state.

The start operation sets the callback(s) associated with the specified token values to the active state. A callback in the active state is invoked at its specified period. Multiple callbacks are specified by performing a logical OR of the token values. Any callbacks specified by this API call already in the active state, remain in the active state and their current timings are not affected. In addition to setting callbacks to the active state, this API can also synchronize the callback timings. The timings of all the active callbacks are reset to start running at the same time reference. The bm_stop() API call changes a callback to the inactive state.

Parameters:

  [in] | aSync | The parameter is set to TRUE to reset the timings of the active callbacks and start them running at the same time reference. The parameter is set to FALSE to leave all active callback timings as they are.
  [in] | aTokens | This parameter specifies the token value(s) of callback(s) to be set to the active state. More than one callback is specified by performing a logical OR of the token values associated with the registered callbacks.

Returns:
  isf_status_t bm_start() returns a value of type isf_status_t providing the status of the start operation.

Return values:

  ISF_SUCCESS | This value is returned if the callback(s) is set to the active state successfully.
  COMM_ERROR_NOEXIST | This value is returned if at least one of the token values specified is invalid because it is not associated with a registered callback.

Constraints:
  The following constraints must be observed when using this function. If these constraints are not met, this API returns an error.
  - aTokens value must be associated with the registered callback(s).

Reentrant: Yes

Link Libraries:
  isf_core.lib

See also:
  bm_stop()

isf_status_t bm_stop | ( | bm_callback_token_t | aTokens | ) |

This API stops one or more callback(s) by setting them to the inactive state.

The stop operation sets the the callback(s) associated with the specified token values to the inactive state. A callback in the inactive state is not invoked. Multiple callbacks are specified by performing a logical OR of the token values. Any callbacks specified by this API call already inactive will remain in the inactive state. To change a callback to the active state, the bm_start() API call is used.

Parameters:

  [in] | aTokens | This parameter specifies the token value(s) of callback(s) to be set to the inactive state. More than one callback is specified by performing a logical OR of the token values associated with the registered callbacks.

Returns:
  isf_status_t bm_stop()returns a value of type isf_status_t providing the status of the stop operation.

Return values:

  ISF_SUCCESS | The callback(s) stopped successfully.
  COMM_ERROR_NOEXIST | At least one of the token values specified is invalid because it is not associated with a registered callback.

Constraints:
  The following constraints must be observed when using this function. If these constraints are not met, this API returns an error.
  - aTokens value must be associated with registered callback(s).

Reentrant: Yes

Link Libraries:
  isf_core.lib

See also:
  bm_start()

isf_status_t bm_unregister_callback | ( | bm_callback_token_t | aTokens | ) |

This API unregisters one or more callbacks.

The Bus Manager allows the removal of a registered callback. After a call to this function, unregistered callbacks no longer exist. To specify the callback to be unregistered, the token returned by bm_register_periodic_callback() is passed to bm_unregister_callback(). Multiple callbacks can be specified by performing a logical OR of the token values. The callback can be in the active or inactive state when it is unregistered.

Parameters:

  [in] | aTokens | This parameter specifies the token value(s) of the callback(s) that are to be unregistered. More than one callback is specified by performing a logical OR of the token values associated with the registered callbacks.

Returns:
  bm_unregister_callback() returns a value of type isf_status_t indicating the status of the unregister operation.

Return values:

  ISF_SUCCESS | This value is returned if the callbacks unregistered successfully.
  COMM_ERROR_NOEXIST | This value is returned if at least one of the token values specified in aTokens is invalid because it is not associated with a registered callback.

Constraints:
  The following constraints must be observed when using this function. If these constraints are not met, this API returns an error.
  - aTokens value must be associated with registered callback(s).

Reentrant: Yes

Link Libraries:
  isf_core.lib

See also:
  bm_register_periodic_callback()